#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "cores.h"

// Paleta de cores pr-definidas para convenincia.
// As cores devem estar em ordem alfabtica.
#define PIX_BRANCO {255, 255, 255}
#define PIX_PRETO  {0, 0, 0}

static Pixel branco = PIX_BRANCO;
static Pixel preto = PIX_PRETO;

Paleta paleta[] = {
  {"ACAFRAO", {244,196,48}},
  {"AGUA_MARINHA", {127,255,212}},
  {"AGUA_MARINHA_MEDIA", {102,205,170}},
  {"ALIZARINA", {227,38,54}},
  {"AMARELO", {255,255,0}},
  {"AMARELO_CLARO", {255,255,224}},
  {"AMARELO_ESVERDEADO", {173,255,47}},
  {"AMARELO_OURO_CLARO", {250,250,210}},
  {"AMARELO_QUEIMADO", {238,173,45}},
  {"AMBAR", {255,191,0}},
  {"AMEIXA", {221,160,221}},
  {"AMENDOA", {255,235,205}},
  {"AMETISTA", {153,102,204}},
  {"ASPARGO", {123,160,91}},
  {"AZUL", {0,0,255}},
  {"AZUL_ACO", {70,130,180}},
  {"AZUL_ACO_CLARO", {176,196,222}},
  {"AZUL_ALICE", {240,248,255}},
  {"AZUL_ARDOSIA", {106,90,205}},
  {"AZUL_ARDOSIA_CLARO", {132,112,255}},
  {"AZUL_ARDOSIA_ESCURO", {72,61,139}},
  {"AZUL_ARDOSIA_MEDIO", {123,104,238}},
  {"AZUL_AREADO", {184,202,212}},
  {"AZUL_CADETE", {95,158,160}},
  {"AZUL_CAMARADA", {5,79,119}},
  {"AZUL_CELESTE", {135,206,235}},
  {"AZUL_CELESTE_PALIDO", {240,255,255}},
  {"AZUL_CELESTE_BRILHANTE", {0,127,255}},
  {"AZUL_CELESTE_CLARO", {135,206,250}},
  {"AZUL_CELESTE_PROFUNDO", {0,191,255}},
  {"AZUL_CLARO", {173,216,230}},
  {"AZUL_COBALTO", {0,71,171}},
  {"AZUL_ESCURO", {0,0,139}},
  {"AZUL_FLOR_DE_MILHO", {100,149,237}},
  {"AZUL_FORCA_AEREA", {93,138,168}},
  {"AZUL_FURTIVO", {30,144,255}},
  {"AZUL_MARINHO", {18,10,143}},
  {"AZUL_MEDIO", {0,0,205}},
  {"AZUL_MEIA_NOITE", {25,25,112}},
  {"AZUL_NAVAL", {0,0,128}},
  {"AZUL_PETROLEO", {8,77,110}},
  {"AZUL_REAL", {0,0,221}},
  {"AZUL_TALCO", {176,224,230}},
  {"AZUL_TAPARUERE", {36,142,255}},
  {"AZUL_VIOLETA", {138,43,226}},
  {"BEGE", {245,245,220}},
  {"BORDO", {128,0,0}},
  {"BORGONHA", {144,0,32}},
  {"BRANCO", PIX_BRANCO},
  {"BRANCO_ANTIGO", {250,235,215}},
  {"BRANCO_FANTASMA", {248,248,255}},
  {"BRANCO_FLORAL", {255,250,240}},
  {"BRANCO_FUMACA", {245,245,245}},
  {"BRANCO_NAVAJO", {255,222,173}},
  {"BRONZE", {205,127,50}},
  {"CAQUI", {240,230,140}},
  {"CAQUI_ESCURO", {189,183,107}},
  {"CARAMELO", {139,87,66}},
  {"CARDO", {216,191,216}},
  {"CARMESIM", {220,20,60}},
  {"CARMIM", {113,47,38}},
  {"CARMIM_CARNACEO", {255,244,240}},
  {"CASTANHO_AVERMELHADO", {138,0,0}},
  {"CASTANHO_CLARO", {210,180,140}},
  {"CENOURA", {237,145,33}},
  {"CEREJA", {222,49,99}},
  {"CEREJA_HOLLYWOOD", {244,0,161}},
  {"CHOCOLATE", {210,105,30}},
  {"CIANO", {0,255,255}},
  {"CIANO_CLARO", {224,255,255}},
  {"CIANO_ESCURO", {0,139,139}},
  {"CINZA", {128,128,128}},
  {"CINZA_ARDOSIA", {112,128,144}},
  {"CINZA_ARDOSIA_CLARO", {119,136,153}},
  {"CINZA_ARDOSIA_ESCURO", {47,79,79}},
  {"CINZA_CLARO", {211,211,211}},
  {"CINZA_ESCURO", {169,169,169}},
  {"CINZA_FOSCO", {105,105,105}},
  {"CINZA_MEDIO", {220,220,220}},
  {"COBRE", {184,115,51}},
  {"CONCHA", {255,245,238}},
  {"CORAL", {255,127,80}},
  {"CORAL_CLARO", {240,128,128}},
  {"COURO", {240,220,130}},
  {"CREME", {255,253,208}},
  {"CREME_DE_MARISCO", {255,228,196}},
  {"CREME_DE_MENTA", {245,255,250}},
  {"DOURADO", {218,165,32}},
  {"DOURADO_ESCURO", {184,134,11}},
  {"DOURADA_LINHACA", {166,170,62}},
  {"DOURADO_PALIDO", {238,232,170}},
  {"ESCARLATE", {255,36,0}},
  {"ESMERALDA", {80,200,120}},
  {"FELDSPATO", {209,146,117}},
  {"FERRUGEM", {183,65,14}},
  {"FULIGEM", {61,43,31}},
  {"GRENA", {131,29,28}},
  {"HERBAL", {46,139,87}},
  {"INDIGO", {75,0,130}},
  {"JADE", {0,168,107}},
  {"JAMBO", {255,69,0}},
  {"LARANJA", {255,165,0}},
  {"LARANJA_ESCURO", {255,140,0}},
  {"LAVANDA", {230,230,250}},
  {"LAVANDA_AVERMELHADA", {255,240,245}},
  {"LILAS", {200,162,200}},
  {"LIMA", {253,233,16}},
  {"LINHO", {250,240,230}},
  {"MADEIRA", {222,184,135}},
  {"MAGENTA", {255,0,255}},
  {"MAGENTA_ESCURO", {139,0,139}},
  {"MALVA", {224,176,255}},
  {"MAMAO_BATIDO", {255,239,213}},
  {"MANA", {240,255,240}},
  {"MARFIM", {255,255,240}},
  {"MARROM", {150,75,0}},
  {"MARROM_AMARELADO", {244,164,96}},
  {"MARROM_CLARO", {165,42,42}},
  {"MARROM_ROSADO", {188,143,143}},
  {"MARROM_SELA", {139,69,19}},
  {"MILHO", {251,236,93}},
  {"MILHO_CLARO", {255,248,220}},
  {"MOCASSIM", {255,228,181}},
  {"MOSTARDA", {255,219,88}},
  {"NEVE", {255,250,250}},
  {"OCRE", {204,119,34}},
  {"ORQUIDEA", {218,112,214}},
  {"ORQUIDEA_ESCURA", {153,50,204}},
  {"ORQUIDEA_MEDIA", {186,85,211}},
  {"OURO", {255,215,0}},
  {"PESSEGO", {255,218,185}},
  {"PRATA", {192,192,192}},
  {"PRETO", PIX_PRETO},
  {"PURPURA", {128,0,128}},
  {"PURPURA_MEDIA", {147,112,219}},
  {"QUANTUM", {17,17,17}},
  {"RENDA_ANTIGA", {253,245,230}},
  {"ROSA", {255,203,219}},
  {"ROSA_BRILHANTE", {255,0,127}},
  {"ROSA_CHOQUE", {252,15,192}},
  {"ROSA_CLARO", {255,182,193}},
  {"ROSA_EMBACADO", {255,228,225}},
  {"ROSA_FORTE", {255,105,180}},
  {"ROSA_PROFUNDO", {255,20,147}},
  {"ROXO", {153,51,153}},
  {"RUTILO", {109,53,26}},
  {"SALMAO", {250,127,114}},
  {"SALMAO_CLARO", {255,160,122}},
  {"SALMAO_ESCURO", {233,150,122}},
  {"SEPIA", {112,87,20}},
  {"SIENA", {255,130,71}},
  {"TERRACOTA", {226,114,91}},
  {"TIJOLO_REFRATARIO", {178,34,34}},
  {"TOMATE", {255,99,71}},
  {"TRIASSICO", {255,36,1}},
  {"TRIGO", {245,222,179}},
  {"TURQUESA", {64,224,208}},
  {"TURQUESA_ESCURA", {0,206,209}},
  {"TURQUESA_MEDIA", {72,209,204}},
  {"TURQUESA_PALIDA", {175,238,238}},
  {"URUCUM", {236,35,0}},
  {"VERDE", {0,128,0}},
  {"VERDE_AMARELADO", {154,205,50}},
  {"VERDE_AZULADO", {0,128,128}},
  {"VERDE_CLARO", {144,238,144}},
  {"VERDE_ESCURO", {0,100,0}},
  {"VERDE_FLORESTA", {34,139,34}},
  {"VERDE_FLUORESCENTE", {204,255,51}},
  {"VERDE_GRAMA", {124,252,0}},
  {"VERDE_LIMA", {50,205,50}},
  {"VERDE_LIMAO", {0,255,0}},
  {"VERDE_MAR_CLARO", {32,178,170}},
  {"VERDE_MAR_ESCURO", {143,188,143}},
  {"VERDE_MAR_MEDIO", {60,179,113}},
  {"VERDE_MILITAR", {120,134,107}},
  {"VERDE_OLIVA", {128,128,0}},
  {"VERDE_OLIVA_ESCURA", {85,107,47}},
  {"VERDE_OLIVA_PARDO", {107,142,35}},
  {"VERDE_PALIDO", {152,251,152}},
  {"VERDE_PARIS", {127,255,0}},
  {"VERDE_PRIMAVERA", {0,255,127}},
  {"VERDE_PRIMAVERA_MEDIO", {0,250,154}},
  {"VERMELHO", {255,0,0}},
  {"VERMELHO_ESCURO", {139,0,0}},
  {"VERMELHO_INDIANO", {205,92,92}},
  {"VERMELHO_VIOLETA", {208,32,144}},
  {"VERMELHO_VIOLETA_MEDIO", {199,21,133}},
  {"VERMELHO_VIOLETA_PALIDO", {219,112,147}},
  {"VIOLETA", {238,130,238}},
  {"VIOLETA_CLARO", {248,203,248}},
  {"VIOLETA_ESCURO", {148,0,211}}
};

void getCor(void *c)
{
  Cor *p = (Cor *) c;

  scanf("%hhd %hhd %hhd", &(p->R), &(p->G), &(p->B));
  while (getchar() != '\n');
}

void prnCor(void *c)
{
  Cor *o = (Cor *) c;
  printf("[%hhd,%hhd,%hhd] ", o->R, o->G, o->B);
}

void *alocaCor(size_t nelem)
{
  return malloc(nelem * sizeof(Cor));
}

void *realocaCor(void *p, size_t nelem)
{
  return realloc(p, nelem * sizeof(Cor));
}

void getCorVet (void *v, int idx, void *o)
{
  *( (Cor *) o) = *((Cor *) v + idx);
  ((Cor *) v + idx)->R = 0;
  ((Cor *) v + idx)->G = 0;
  ((Cor *) v + idx)->B = 0;
}

void putCorVet (void *v, int idx, void *o)
{
  *((Cor *) v + idx) = *( (Cor *) o);
}

void prnCorVet(void *v, int idx)
{
  prnCor ((Cor *) v + idx);
}

/* Obtm uma cor da paleta de cores a partir de seu nome.
  Se nome no  encontrado, retorna pixel branco.
 */
Pixel *pickColor(char *nomeCor)
{
  int i, size = sizeof(paleta) / sizeof(Paleta);
  
  for(i=0; i < size; ++i)
    if ( ! strcmp(paleta[i].nomeCor, nomeCor) )
      return &(paleta[i].cor);
    else if ( strcmp(paleta[i].nomeCor, nomeCor) > 0 )
      return &branco;

  return &branco;

}

/* Obtm aleatoriamente uma cor da paleta de cores */
Pixel *pickAnyColor()
{
  int size = sizeof(paleta) / sizeof(Paleta);

  return &(paleta[rand() % size].cor);  
}


